#ifndef _IMMEDIATE_PARAM_H_
#define _IMMEDIATE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/ImmediateValueAbstraction.hpp>

namespace cli {

template < class Type >
class ImmediateParam final : public Param {
	Type m_data;

public:
	ImmediateParam ( Type value ) : m_data ( std::move ( value ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & ) const override {
		return std::make_shared < abstraction::ImmediateValueAbstraction < Type > > ( m_data );
	}

	virtual bool getImplicitMove ( ) const override {
		return true;
	}
};

} /* namespace cli */

#endif /* _IMMEDIATE_PARAM_H_ */
