#ifndef _CLI_STATEMENT_PARAM_H_
#define _CLI_STATEMENT_PARAM_H_

#include <ast/Param.h>

namespace cli {

class StatementParam final : public Param {
	std::shared_ptr < Statement > m_statement;

public:
	StatementParam ( std::shared_ptr < Statement > statement ) : m_statement ( statement ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		return m_statement->translateAndEval ( nullptr, environment );
	}

	virtual bool getImplicitMove ( ) const override {
		return false;
	}
};

} /* namespace cli */

#endif /* _CLI_STATEMENT_PARAM_H_ */
