#ifndef _CLI_RESULT_FILE_STATEMENT_H_
#define _CLI_RESULT_FILE_STATEMENT_H_

#include <ast/Statement.h>

#include <common/XmlComposerHelper.h>

namespace cli {

class ResultFileStatement final : public Statement {
	std::unique_ptr < cli::Arg > m_file;

public:
	ResultFileStatement ( std::unique_ptr < cli::Arg > file ) : m_file ( std::move ( file ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override {
		std::string file = m_file->eval ( environment );

		return abstraction::XmlComposerHelper::eval ( prev, file );
	}

};

} /* namespace cli */

#endif /* _CLI_RESULT_FILE_STATEMENT_H_ */
