#ifndef _CLI_SINGLE_STATEMENT_H_
#define _CLI_SINGLE_STATEMENT_H_

#include <ast/Statement.h>
#include <registry/Registry.h>
#include <ast/options/CategoryOption.h>

namespace cli {

class SingleStatement final : public Statement {
	std::unique_ptr < cli::Arg > m_name;
	ext::vector < std::unique_ptr < cli::Arg > > m_templateParams;
	ext::vector < std::unique_ptr < Param > > m_params;
	std::unique_ptr < CategoryOption > m_category;
	ext::vector < bool > m_moves;

public:
	SingleStatement ( std::unique_ptr < cli::Arg > name, ext::vector < std::unique_ptr < cli::Arg > > templateParams, ext::vector < std::unique_ptr < Param > > params, std::unique_ptr < CategoryOption > options, ext::vector < bool > moves );

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override;
};

} /* namespace cli */

#endif /* _CLI_SINGLE_STATEMENT_H_ */
